function [p1 p2 i]= ...
  GoSimCom(p1,p2,i,h,stop,count,loop_flag,antal_decimaler)
  
%p1,p2... = param1, param2...

%p1=räknare för progress bar, ger minst heltal mellan 0 och
% 100 men kan ge större steg om sampeltiden är stor i 
%förhållande till stopptiden
%p2=id för tic, används för realtidsloop

%loop_flag:
%0: for-loop, vanlig
%1: for-loop, realtid
%2: while-loop, vanlig
%3: while-loop, realtid

%denna funktion skickar en siffra mellan 0 och 100 till
%progress bar i GoSim under simuleringen som motsvarar
%hur långt den kommit i procent.

%vid 9.1 blir det fel pga av decimalnoggrannhet
%fixar med floor(i/stop/10*100*10) ist för ursprungliga
%floor(i/stop*100)

%octave accepterar inte inf som stop-parameter i for-loopen
%så behöver inte tänka på det fallet


%om stegen är större än 1 procent kommer de alltid visas, 
%vilket är bra eftersom upplösningen är större än en hundradel
if(floor(i/stop/10*100*10)>=p1)%upplösning 1% (max)
  p1++;%upplösning 1% (max)
  display(["g_s|g" num2str(floor(i/stop/10*100*10) ) ]);
  %floor(i/stop/10*100*10)
end

%för serier när man inte kommer till stop som t.ex.
%[1:2:10]=(1   3   5   7   9)  som bara går till 9
%så att progress bar blir full
%kan ge 100 pga av massa decimaler när den ovan också gör det
%så det blir 2 ggr, det är ändå en bra allmän lösning 
%för en mätare
%denna täcker även om man har större sampeltid än 
%stopptid (fyllt i fel)
if(stop-i<h && stop-i!=0)
  display(["g_s|g" num2str(100) ]);
  %100
end

%skriver ut toc för simuleringstid. tic sätts i början av
% skriptet
if(i==stop)
  time=toc;
  display(["Octave simulation time: " num2str(time) " seconds."]);
end


if(loop_flag==2 || loop_flag==3)%while-loop, uppdatera i
  i=str2num(sprintf(["%." num2str(antal_decimaler) "f"], i+h));
  %str2num(sprintf("%.4f", 1+0.0001+.0001+.0001))
  %.4 betyder att 4 decimaler ska tas med i strängen
  %detta ger: 
  %str2num(sprintf("%.4f", 1+0.0001+.0001+.0001))==1.0003
  %ger 1. 
  %Det blir inte 1 om man gör vanlig addition pga av decimalgrejs. 
  %många funktioner behöver att i blir exakt satt precis som 
  %i for-loopen
end

%realtidsloop
if(loop_flag==1 || loop_flag==3)
    pause(h-toc(p2) );
    p2=tic;
end


