function [param,param1]=...
  RealTimeScope(param,param1,i,h,stop,count,sn,in0, in1, in2)
  
%har inga signaler ut, skriver endast i fil som sen gnuplot
%i GoSim plottar


%param är en string, pathen till temp-mappen och namnet 
%på scope-blocket som används för att få rätt filnamn. 
%param1 är tidshorisonten som ska plottas, filen skrivs över
%när tidshorisonten är slut

if nargin==8 || nargin==9 || nargin==10  %nargin = number of arguments in
  
  %första iterationen skapas filens id och filen töms, andra gången läggs data till
  if count==1
    file_id = fopen ([param "scope.dat_1"], "w");%skapar fil-id med write och tar bort allt i den
  elseif (mod(i,param1)==0 && i!=stop ) %tidshorisonten är slut, skriver över filen, men inte sista sampeln så man kan se sista plotten när simuleringen är slut
    file_id = fopen ([param "scope.dat_1"], "w");%skapar fil-id med write och tar bort allt i den
  else
    file_id = fopen ([param "scope.dat_1"], "a");%skapar fil-id och lägger till data i slutet, append
  endif

  format long; %för att få många decimaler med fdisp
  fprintf(file_id,'%f  %f \n', i, in0);% %i är integer, %f är en real
  
  fclose(file_id);%stänger filen så andra program kan använda den
  format short;%så att octave skriver ut normalt antal 
  %decimaler/signifikanta siffror eller vad det är efter detta

endif

if nargin==9 || nargin==10  %nargin = number of arguments in
  
  %första iterationen skapas filens id och filen töms, andra gången läggs data till
  if count==1
    file_id = fopen ([param "scope.dat_2"], "w");%skapar fil-id med write och tar bort allt i den
  elseif (mod(i,param1)==0 && i!=stop ) %tidshorisonten är slut, skriver över filen, men inte sista sampeln så man kan se sista plotten när simuleringen är slut
    file_id = fopen ([param "scope.dat_2"], "w");%skapar fil-id med write och tar bort allt i den
  else
    file_id = fopen ([param "scope.dat_2"], "a");%skapar fil-id och lägger till data i slutet, append
  endif

  format long; %för att få många decimaler med fdisp
  fprintf(file_id,'%f  %f \n', i, in1);% %i är integer, %f är en real
  
  fclose(file_id);%stänger filen så andra program kan använda den
  format short;%så att octave skriver ut normalt antal 
  %decimaler/signifikanta siffror eller vad det är efter detta

endif

if nargin==10  %nargin = number of arguments in
  
  %första iterationen skapas filens id och filen töms, andra gången läggs data till
  if count==1
    file_id = fopen ([param "scope.dat_3"], "w");%skapar fil-id med write och tar bort allt i den
  elseif (mod(i,param1)==0 && i!=stop ) %tidshorisonten är slut, skriver över filen, men inte sista sampeln så man kan se sista plotten när simuleringen är slut
    file_id = fopen ([param "scope.dat_3"], "w");%skapar fil-id med write och tar bort allt i den
  else
    file_id = fopen ([param "scope.dat_3"], "a");%skapar fil-id och lägger till data i slutet, append
  endif

  format long; %för att få många decimaler med fdisp
  fprintf(file_id,'%f  %f \n', i, in2);% %i är integer, %f är en real
  
  fclose(file_id);%stänger filen så andra program kan använda den
  format short;%så att octave skriver ut normalt antal 
  %decimaler/signifikanta siffror eller vad det är efter detta

endif