function [p1,p2,out1]= ...
  SignalGenerator(p1,p2,i,h,stop,count,sn)
  
%p1,p2... = param1, param2...
%sn = script name
  
%p1 är signaltyp
%p2 är perioden i sekunder

%amplituden är alltid 1

%negativ period ger en våg som inte är det jag vill men
%det är en våg, så låter det vara. Är perioden 0 blir det  
%NaN, så jag sätter 0 ut då.
if(p2==0)
  display([sn " signal generator, incorrect period selection, value set to 0."]);
  out1=0;



%fyrkantsvåg från -1 till 1
elseif(p1==0)
  temp=sin(2*pi*i/(p2));
  if(temp==0)
    out1=0;
  elseif(temp>0)
    out1=1;
  elseif(temp<0)
    out1=-1;
  end

                      
%halv fyrkantsvåg från 0 till 1 ⊓_⊓_⊓_⊓_⊓_
elseif(p1==1)
  temp=sin(2*pi*i/(p2));
  if(temp>0)
    out1=1;
  else
    out1=0;
  end

  
%halv fyrkantsvåg från 0 till 1 _⊓_⊓_⊓_⊓_⊓
elseif(p1==2)
  temp=sin(2*pi*i/(p2));
  if(temp<0)
    out1=1;
  else
    out1=0;
  end



%sågtand från -1 till 1 /|/|/|/|/|/|
elseif(p1==3)
  out1=mod(2*i/p2,2)-1;
  if(out1==-1)%noll i extrempunkterna
    out1=0;
  end


%sågtand från 0 till 1 /|/|/|/|/|/|
elseif(p1==4)
  out1=mod(i/p2,1);


%halv sågtand från 0 till 1 /|__/|__/|__/|__
elseif(p1==5)
  temp=mod(2*i/p2,2);
  if(temp<1)
    out1=temp;
  else %mindre än 2 och större än 1, mod ordnar det
    out1=0;
  end  


%halv sågtand från 0 till 1 __/|__/|__/|__/|
elseif(p1==6)
  temp=sin(2*pi*i/(p2));
  if(temp>=0)
    out1=0;
  else 
    out1=mod(2*i/p2,1);
  end  



%sågtand från -1 till 1 |\|\|\|\|\|\
elseif(p1==7)
  out1=-(mod(2*i/p2,2)-1);
  if(out1==1)%noll i extrempunkterna
    out1=0;
  end


%sågtand från 0 till 1 |\|\|\|\|\|\
elseif(p1==8)
  out1=mod(1-i/p2,1);


%halv sågtand från 0 till 1 |\__|\__|\__|\__
elseif(p1==9)
  temp=sin(2*pi*i/(p2));
  if(temp<=0)
    out1=0;
  else 
    out1=mod(1-2*i/p2,1);
  end  


%halv sågtand från 0 till 1 __|\__|\__|\__|\
elseif(p1==10)
  temp=sin(2*pi*i/(p2));
  if(temp>=0)
    out1=0;
  else 
    out1=mod(1-2*i/p2,1);
  end  



%                     /|  /|  /|  /|  
%mixad, från 0 till 1 ||__||__||__||__
elseif(p1==11)
  temp=sin(2*pi*i/(p2));
  if(temp<=0)
    out1=0;
  else 
    out1=mod(0.5+i/p2,1);
  end  


%                       /|  /|  /|  /|  
%mixad, från 0 till 1 __||__||__||__||
elseif(p1==12)
  temp=sin(2*pi*i/(p2));
  if(temp>=0)
    out1=0;
  else 
    out1=mod(i/p2,1);
  end  


%                     |\  |\  |\  |\   
%mixad, från 0 till 1 ||__||__||__||__
elseif(p1==13)
  temp=sin(2*pi*i/(p2));
  if(temp<=0)
    out1=0;
  else 
    out1=mod(1-i/p2,1);
  end  


%                       |\  |\  |\  |\
%mixad, från 0 till 1 __||__||__||__||
elseif(p1==14)
  temp=sin(2*pi*i/(p2));
  if(temp>=0)
    out1=0;
  else 
    out1=mod(.5-i/p2,1);
  end  


%triangelvåg från -1 till 1  /\/\/\/\/\
elseif(p1==15)
  temp=mod(4*i/p2,4)-1;
  if(temp<=1)
    out1=temp;
  elseif(temp>1)
    out1=2-temp;
  end  


%triangelvåg från 0 till 1  /\/\/\/\/\
elseif(p1==16)
  temp=mod(2*i/p2,2);
  if(temp<=1)
    out1=temp;
  elseif(temp>1)
    out1=2-temp;
  end  



%diskret Dirac deltafunktion |_____|_____|_____|_____
elseif(p1==17)
  if(mod(i,p2)==0 )
    out1=1;
  else
    out1=0;
  end


%diskret Dirac deltafunktion _____|_____|_____|_____|
elseif(p1==18)
  %decimalproblem...blir inte exakt heltal, får acceptera lite under p2 eller lite över 0
  if(mod(i+h,p2)>p2-10^-10 && mod(i+h,p2)<p2 || mod(i+h,p2)<10^-10 )
    out1=1;
  else
    out1=0;
  end



%sinus
elseif(p1==19)
  out1=sin(2*pi*i/(p2));


%cosinus
elseif(p1==20)
  out1=cos(2*pi*i/(p2));
  
else
  display([sn " signal generator, incorrect signal type selection, value set to 0."]);
  out1=0;
end

